<?php
/*
Plugin Name: HidePost
Plugin URI: http://nguyenthanhcong.com/hidepost-plugin-for-wordpress/
Description: Protect a part of your post by using [hidepost] and [/hidepost]  between the protected content.
Version: 2.3.2
Author: Fu4ny
Author URI: http://nguyenthanhcong.com
*/
include("option_init.php");

function hidepost_replace_pattern_link($the_text){//Replace pattern with the link
    stripslashes($the_text);
    $the_text = str_replace('%login%','<a href='.get_bloginfo('url').'/wp-login.php'.'>Login</a>',$the_text);
    $the_text = str_replace('%register%','<a href='.get_bloginfo('url').'/wp-login.php?action=register'.'>Register</a>',$the_text);
    return $the_text;
}

function hidepost_replace_pattern(){//Replace pattern with the link
global $hidepost_content_text, $hidepost_link_text;
    $hidepost_content_text = hidepost_replace_pattern_link($hidepost_content_text);
    $hidepost_link_text = hidepost_replace_pattern_link($hidepost_link_text);
}


function hidepost_replace_hide($content) {
	global $current_user, $user_ID, $hidepost_content_text,$user_level, $m_id;
	$m_id++;
	preg_match_all('#\[hidepost(.*?)\](.*?)\[/hidepost\]#sie', $content, $matches);//Find the hidepost tag
	$level_tag = $matches[1][$m_id];
	$max_level = 0;
	if ($level_tag[0] == '=') {
		$max_level = $level_tag[1]; //Get the level require
	}
    //Will allow bot if user want
	$hidepost_allow_bot = get_option('hidepost_allow_bot');
	if ($hidepost_allow_bot == 1) {
		$useragent = $_SERVER['HTTP_USER_AGENT'];
		if (stristr('google msnbot ia_archiver lycos jeeves scooter fast-webcrawler slurp@inktomi turnitinbot technorati yahoo findexa findlinks gaisbo zyborg surveybot bloglines blogsearch pubsub syndic8 userland  gigabot become.com', $useragent) !== false) {
				return $matches[2][$m_id];
			}
	}
	get_currentuserinfo();
	if ($user_ID == ''){//If not logged in
		return $hidepost_content_text;
	}
	if ($user_level < $max_level) {//Not meet the require level
		$show = '<b>You must be a(n) <font size=3 color=BLUE>';
		switch ($max_level):
			case 0: $show .= 'Subscriber';
					break;
			case 1: $show .= 'Contributor';
					break;
			case 2: $show .= 'Author';
					break;
			case 3:
			case 4:
			case 5:
			case 6:
			case 7: $show .= 'Editor';
					break;
			case 8:
			case 9: $show .= 'Administrator';
					break;
		endswitch;
		$show .= ' </font>to view this content</b>';
		return $show;
	}
	return $matches[2][$m_id]; //Or return the content if user can see
}
function hidepost_replace_link($content) {
	global $current_user, $user_ID, $hidepost_link_text, $m_id;
	$m_id++;
	preg_match_all('#\<a(.*?)\>(.*?)\</a\>#sie', $content, $matches);  //Find all the link
	get_currentuserinfo();
	if ($user_ID == ''){//If not logged in
		return $hidepost_link_text;
	} else {return $matches[0][$m_id];} //Or return the content if user can see
}

function hidepost_filter_post($content) {
    global $m_id, $hidepost_hide_link, $hidepost_hide_content;
	hidepost_replace_pattern();
	//Protect the link
	if ($hidepost_hide_link == 1) {
	$m_id = -1;//Magic ^.^
	$content = preg_replace('#\<a(.*?)\>(.*?)\</a\>#sie','hidepost_replace_link($content)',$content);
	}
	//Protect content
	if ($hidepost_hide_content == 1) {
	$m_id = -1;
	$content = preg_replace('#\[hidepost(.*?)\](.*?)\[/hidepost\]#sie','hidepost_replace_hide($content)',$content);
	}
	return $content;
}

//Add the Option Page
function hidepost_options()	{
        if (function_exists('add_options_page')) {
            add_options_page('HidePost Options','HidePost', 6, 'hidepost/options.php');
        }
    }

function the_view($special_var){
	return htmlspecialchars(stripslashes($special_var));
}

//Replace your old tag with new [hidepost] tag
function hidepost_search_and_replace($old_tag,$old_close_tag,$new_tag) {
    global $wpdb;
    if ($new_tag <> "[hidepost]") { //Just double checking user want to replace
        return 'Your new tag must be [hidepost]';
    }
    if (($old_tag=="[hidepost]") && ($old_close_tag=="[/hidepost]")) {
        return 'Your tag already newest';
    }

    $new_close_tag = "[/hidepost]";
    echo 'Find '.$old_tag.' and replace with '.$new_tag.'... ' ;
    $query = "UPDATE $wpdb->posts ";
    $query .= "SET post_content = ";
    $query .= "REPLACE(post_content, \"$old_tag\", \"$new_tag\") ";
    $wpdb->get_results($query);
    echo 'Completed  <br/>';

    echo 'Find '.$old_close_tag.' and replace with '.$new_close_tag.'... ' ;
    $query = "UPDATE $wpdb->posts ";
    $query .= "SET post_content = ";
    $query .= "REPLACE(post_content, \"$old_close_tag\", \"$new_close_tag\") ";
    $wpdb->get_results($query);
    echo 'Completed  <br/>';

    return 'All done, Enjoy using HidePost<br />';
}


//Hook function
add_filter('the_content', 'hidepost_filter_post');
add_action('admin_menu', 'hidepost_options');
?>